/* Copyright 1995 Jim McBeath
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that my name not be used in advertising
 * or publicity pertaining to distribution of the software without
 * specific, written prior permission.  I make no representations about
 * the suitability of this software for any purpose.  It is provided
 * "as is" without express or implied warranty.
 *
 * I disclaim all warranties with regard to this software, including all
 * implied warranties of merchantability and fitness.  In no event shall
 * I be liable for any special, indirect or consequential damages or any
 * damages whatsoever resulting from loss of use, data or profits, whether
 * in an action of contract, negligence or other tortious action, arising
 * out of or in connection with the use or performance of this software.
 */
/* urlctx.c - url context stuff
 *
 * Jim McBeath, October 30, 1994
 */

#include "urlopen.h"

int		/* 0 if OK */
UrlNewContext(rctx)
UrlContext **rctx;
{
	UrlContext *ctx;

	ctx = (UrlContext *)UrlMalloc(sizeof(UrlContext));
	if (!ctx) {
		return ENOMEM;
	}
	memset(ctx,0,sizeof(UrlContext));
	*rctx = ctx;
	return 0;
}

int		/* 0 if OK */
UrlSetProxy(ctx,proxy_url)
UrlContext *ctx;
char *proxy_url;
{
	UPARSE *proxy;

	proxy = UrlParse(ctx,proxy_url);
	if (!proxy)
		return UrlGetErrno(ctx);
	if (!proxy->access)
		proxy->access = "http";
	if (!proxy->host || !proxy->host[0])
		proxy->host = "localhost";
	if (ctx->use_proxy)
		UrlFreeParse(ctx->use_proxy);
	ctx->use_proxy = proxy;
	return 0;
}

void
UrlSetIconPrefix(ctx,prefix)
UrlContext *ctx;
char *prefix;
{
	ctx->icon_prefix = UrlStrdup(prefix);
}

/* end */
