/* Copyright 1995 Jim McBeath
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that my name not be used in advertising
 * or publicity pertaining to distribution of the software without
 * specific, written prior permission.  I make no representations about
 * the suitability of this software for any purpose.  It is provided
 * "as is" without express or implied warranty.
 *
 * I disclaim all warranties with regard to this software, including all
 * implied warranties of merchantability and fitness.  In no event shall
 * I be liable for any special, indirect or consequential damages or any
 * damages whatsoever resulting from loss of use, data or profits, whether
 * in an action of contract, negligence or other tortious action, arising
 * out of or in connection with the use or performance of this software.
 */
/* urlext.c - filename extension to contents type mapping
 *
 * Jim McBeath, October 26, 1994
 */

#include "urlopen.h"

char *
UrlGetExtContType(ctx,ext)
UrlContext *ctx;
char *ext;		/* such as "html" */
{
	return UrlSymFind(ctx,ctx->extmap,ext);
}

int	/* 0 if OK */
UrlSetExtContType(ctx,ext,cont)
UrlContext *ctx;
char *ext;
char *cont;
{
	return UrlSymSet(ctx,ctx->extmap,ext,cont);
}

int	/* 0 if OK */
UrlInitExtContMap(ctx)
UrlContext *ctx;
{
	ctx->extmap = UrlSymTabInit(ctx,"ext");
	if (!ctx->extmap)
		return UrlGetErrno(ctx);

	/* set up standard mappings */
	UrlSetExtContType(ctx,"ps","application/postscript");
	UrlSetExtContType(ctx,"eps","application/postscript");

	UrlSetExtContType(ctx,"au","audio/basic");

	UrlSetExtContType(ctx,"gif","image/gif");
	UrlSetExtContType(ctx,"jpe","image/jpeg");
	UrlSetExtContType(ctx,"jpg","image/jpeg");
	UrlSetExtContType(ctx,"jpeg","image/jpeg");
	UrlSetExtContType(ctx,"tif","image/tiff");
	UrlSetExtContType(ctx,"tiff","image/tiff");
	UrlSetExtContType(ctx,"xwd","image/xwd");

	UrlSetExtContType(ctx,"c","text/plain");
	UrlSetExtContType(ctx,"h","text/plain");
	UrlSetExtContType(ctx,"txt","text/plain");
	UrlSetExtContType(ctx,"text","text/plain");

	UrlSetExtContType(ctx,"htm","text/html");
	UrlSetExtContType(ctx,"html","text/html");

	UrlSetExtContType(ctx,"mpe","video/mpeg");
	UrlSetExtContType(ctx,"mpg","video/mpeg");
	UrlSetExtContType(ctx,"mpeg","video/mpeg");

	/* TBD - need to fill this out */
	/* TBD - go read $HOME/.mime.type so user can add more */
}

/* end */
