#!/bin/sh -
#Output compile and link flags for urlopen
#Copyright 1995 Jim McBeath

#$2 is termdir; if it exists, we compile with -DTERM
echo_cflags(){
	[ X"$2" = X ] && echo "No value specified for -cflags" && exit 1
	[ -d "$2" ] && echo "-DTERM"
}

#$2 is termdir
echo_includes(){
	[ X"$2" = X ] && echo "No value specified for -includes" && exit 1
	[ -d "$2" ] && echo "-I$2"
}

#no args
echo_ldlibs(){
	uname_s=`uname -s`
	uname_r=`uname -r`
	case $uname_s$uname_r in
	SunOS5.*) echo "-ldl -lsocket -lnsl -lintl";;
	*) ;;		#for anything else, output nothing
	esac
}

#$2 is term library
echo_termlib(){
	[ X"$2" = X ] && echo "No value specified for -termlib" && exit 1
	[ -r "$2" ] && echo "$2"
}

#$2 is library on which to run ranlib
do_ranlib(){
	[ X"$2" = X ] && echo "No value specified for -ranlib" && exit 1
	for p in `echo $PATH | tr ':' ' '`; do
		if [ -f $p/ranlib ]; then
			echo $p/ranlib "$2"
			$p/ranlib "$2"
			exit $?
		fi
	done
	echo No ranlib found on this machine
}

case $1 in
	-cflags)  echo_cflags "$@"; exit 0;;
	-includes)echo_includes "$@"; exit 0;;
	-ldlibs) echo_ldlibs; exit 0;;
	-ranlib) do_ranlib "$@"; exit 0;;
	-termlib) echo_termlib "$@"; exit 0;;
	*)	  echo "Unknown argument $1"; exit 1;;
esac
