/* Copyright 1995 Jim McBeath
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that my name not be used in advertising
 * or publicity pertaining to distribution of the software without
 * specific, written prior permission.  I make no representations about
 * the suitability of this software for any purpose.  It is provided
 * "as is" without express or implied warranty.
 *
 * I disclaim all warranties with regard to this software, including all
 * implied warranties of merchantability and fitness.  In no event shall
 * I be liable for any special, indirect or consequential damages or any
 * damages whatsoever resulting from loss of use, data or profits, whether
 * in an action of contract, negligence or other tortious action, arising
 * out of or in connection with the use or performance of this software.
 */
/* urlfread.c - read from a FILE*
 *
 * Jim McBeath, October 29, 1994
 */

#include "urlopen.h"

/* Gets a line up to and including newline, no matter how long */
char *		/* belongs to us */
UrlFGetLine(f)
FILE *f;
{
	static char *buf=0;
	static int buflen=0;
	int n;
#define CHUNKSIZE 1000
	if (!buf) {
		buflen = CHUNKSIZE;
		buf = UrlMalloc(buflen);
		if (!buf) {
			buflen = 0;
			/* TBD - would be nice to set ENOMEM error here */
			return 0;
		}
	}
	buf[0] = 0;
	fgets(buf,buflen-1,f);
	n = strlen(buf);
	if (n<buflen-1)
		return buf;
/* TBD - look for trailing backslash? */
	/* Well, we didn't get it in one read, need to try more */
/* TBD - do this later */
return buf;
}

/* Like UrlFGetLine, but discards the newline (and CR before it)*/
char *		/* belongs to us */
UrlFGetLineNoNl(f)
FILE *f;
{
	char *l;
	int llen;

	l = UrlFGetLine(f);
	if (!l || !*l)
		return l;
	llen = strlen(l);
	if (l[llen-1]=='\n') {
		l[--llen] = 0;
		if (llen>0 && l[llen-1]=='\015') {
			l[--llen] = 0;	/* throw out CR before LF */
		}
	}
	return l;
}

/* end */
