/* Copyright 1995 Jim McBeath
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that my name not be used in advertising
 * or publicity pertaining to distribution of the software without
 * specific, written prior permission.  I make no representations about
 * the suitability of this software for any purpose.  It is provided
 * "as is" without express or implied warranty.
 *
 * I disclaim all warranties with regard to this software, including all
 * implied warranties of merchantability and fitness.  In no event shall
 * I be liable for any special, indirect or consequential damages or any
 * damages whatsoever resulting from loss of use, data or profits, whether
 * in an action of contract, negligence or other tortious action, arising
 * out of or in connection with the use or performance of this software.
 */
/* urlicon.c - icon stuff
 *
 * Jim McBeath, November 18, 1994
 */

#include "urlopen.h"

char *
UrlGetContIconType(ctx,cont)
UrlContext *ctx;
char *cont;		/* such as "text/html" */
{
	return UrlSymFindSlashStar(ctx,ctx->cont_icon_map,cont);
}

int	/* 0 if OK */
UrlSetContIconType(ctx,cont,icon)
UrlContext *ctx;
char *cont;
char *icon;
{
	return UrlSymSet(ctx,ctx->cont_icon_map,cont,icon);
}

int	/* 0 if OK */
UrlInitContIconMap(ctx)
UrlContext *ctx;
{
	ctx->cont_icon_map = UrlSymTabInit(ctx,"cont_icon");
	if (!ctx->cont_icon_map)
		return UrlGetErrno(ctx);

	/* set up standard mappings */
	UrlSetContIconType(ctx,"application/binary","binary.xbm");
	UrlSetContIconType(ctx,"application/directory","directory.xbm");
	UrlSetContIconType(ctx,"application/executable","executable.xbm");
	UrlSetContIconType(ctx,"application/postscript","postscript.xbm");
	UrlSetContIconType(ctx,"audio/basic","audio.xbm");
	UrlSetContIconType(ctx,"audio/*","audio.xbm");
	UrlSetContIconType(ctx,"gopher/binary","text.xbm");
	UrlSetContIconType(ctx,"gopher/image","image.xbm");
	UrlSetContIconType(ctx,"gopher/index","directory.xbm");
	UrlSetContIconType(ctx,"gopher/menu","directory.xbm");
	UrlSetContIconType(ctx,"gopher/movie","video.xbm");
	UrlSetContIconType(ctx,"gopher/plain","text.xbm");
	UrlSetContIconType(ctx,"gopher/sound","audio.xbm");
	UrlSetContIconType(ctx,"gopher/telnet","telnet.xbm");
	UrlSetContIconType(ctx,"image/gif","image.xbm");
	UrlSetContIconType(ctx,"image/jpeg","image.xbm");
	UrlSetContIconType(ctx,"image/tiff","image.xbm");
	UrlSetContIconType(ctx,"image/xwd","image.xbm");
	UrlSetContIconType(ctx,"text/plain","text.xbm");
	UrlSetContIconType(ctx,"text/html","html.xbm");
	UrlSetContIconType(ctx,"unknown","unknown.xbm");
	UrlSetContIconType(ctx,"video/mpeg","video.xbm");

	/* TBD - need to fill this out */
	/* TBD - go read some rc file so user can add more */
}

/* end */
