/* Copyright 1995 Jim McBeath
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that my name not be used in advertising
 * or publicity pertaining to distribution of the software without
 * specific, written prior permission.  I make no representations about
 * the suitability of this software for any purpose.  It is provided
 * "as is" without express or implied warranty.
 *
 * I disclaim all warranties with regard to this software, including all
 * implied warranties of merchantability and fitness.  In no event shall
 * I be liable for any special, indirect or consequential damages or any
 * damages whatsoever resulting from loss of use, data or profits, whether
 * in an action of contract, negligence or other tortious action, arising
 * out of or in connection with the use or performance of this software.
 */
/* urlinit.c - standard init for url package
 *
 * Jim McBeath, October 14, 1994
 */

#include "urlopen.h"

int		/* 0 if OK, errno if problem */
UrlInit(rctx)
UrlContext **rctx;
{
	int t;
	UrlContext *ctx;

	t = UrlNewContext(&ctx);
	if (t)
		return t;
	UrlFileRegister(ctx);
	UrlFtpRegister(ctx);
	UrlGopherRegister(ctx);
	UrlHttpRegister(ctx);
	UrlLocalfileRegister(ctx);
/* TBD - wais, telnet, tn3250, news, mailto */

	UrlInitExtContMap(ctx);
	UrlInitContIconMap(ctx);
	UrlInitContCommands(ctx);
	*rctx = ctx;
	return 0;
}

/* end */
