/* Copyright 1995 Jim McBeath
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that my name not be used in advertising
 * or publicity pertaining to distribution of the software without
 * specific, written prior permission.  I make no representations about
 * the suitability of this software for any purpose.  It is provided
 * "as is" without express or implied warranty.
 *
 * I disclaim all warranties with regard to this software, including all
 * implied warranties of merchantability and fitness.  In no event shall
 * I be liable for any special, indirect or consequential damages or any
 * damages whatsoever resulting from loss of use, data or profits, whether
 * in an action of contract, negligence or other tortious action, arising
 * out of or in connection with the use or performance of this software.
 */
/* urlmem.c - memory routines
 *
 * Jim McBeath, November 1, 1994
 */

#include <stdio.h>
#include "urlopen.h"

extern void *malloc();
extern void *realloc();

void
UrlNoMem(n)
int n;
{
#if 1	/* debug */
	fprintf(stderr,"out of memory\n");
#endif
}

void *
UrlMalloc(n)
unsigned int n;
{
	void *p;

	p = malloc(n);
	if (!p)
		UrlNoMem(n);
	return p;
}

void *
UrlRealloc(p,n)
void *p;
unsigned int n;
{
	void *newp;

	newp = realloc(p,n);
	if (!newp)
		UrlNoMem(n);
	return newp;
}

void
UrlFree(p)
void *p;
{
	free(p);
}

char *
UrlStrdup(s)
char *s;
{
	unsigned int l;
	char *p;

	l = strlen(s)+1;
	p = UrlMalloc(l);
	if (p)
		strcpy(p,s);
	return p;
}

/* end */
