/* Copyright 1995 Jim McBeath
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that my name not be used in advertising
 * or publicity pertaining to distribution of the software without
 * specific, written prior permission.  I make no representations about
 * the suitability of this software for any purpose.  It is provided
 * "as is" without express or implied warranty.
 *
 * I disclaim all warranties with regard to this software, including all
 * implied warranties of merchantability and fitness.  In no event shall
 * I be liable for any special, indirect or consequential damages or any
 * damages whatsoever resulting from loss of use, data or profits, whether
 * in an action of contract, negligence or other tortious action, arising
 * out of or in connection with the use or performance of this software.
 */
/* urlmsg.c - give messages to user
 *
 * Jim McBeath, November 1, 1994
 */

#include <varargs.h>
#include "urlopen.h"

void
UrlSetMessageFunc(ctx,func)
UrlContext *ctx;
void (*func)();
{
	ctx->msgfunc = func;
}

void
UrlMessage(ctx,type,s)
UrlContext *ctx;
int type;	/* one of URL_MSG_* */
char *s;
{
	if (ctx->msgfunc) {
		(*(ctx->msgfunc))(ctx,type,s);
	} else {
		printf("%s\n",s);
	}
}

void
UrlMessagef(ctx,type,fmt,va_alist)
UrlContext *ctx;
int type;	/* one of URL_MSG_* */
char *fmt;
va_dcl
{
	va_list pvar;
	char buf[1000];

	va_start(pvar);
	vsprintf(buf,fmt,pvar);
	UrlMessage(ctx,type,buf);
	va_end(pvar);
}

void
UrlShowBytesRead(uf)
UFILE *uf;
{
	UrlContext *ctx;

	ctx = uf->ctx;
	if (uf->filesize) {
		UrlMessagef(ctx,URL_MSG_READING,
			"Read %d bytes of %d",uf->bytesread,uf->filesize);
	} else {
		UrlMessagef(ctx,URL_MSG_READING,
			"Read %d bytes",uf->bytesread);
	}
}

/* end */
